// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <DbgHelp.h>
#pragma comment(lib, "dbghelp.lib")

void test()
{
	printf("test\n");
}

int _tmain(int argc, _TCHAR* argv[])
{
	test();

	DWORD  error;

	SymSetOptions(SYMOPT_LOAD_LINES);

	HANDLE thisProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, ::GetCurrentProcessId());
	// Ǵ thisProcess = GetCurrentProcess();

	if (!SymInitialize(thisProcess, NULL, TRUE))
	{
		error = GetLastError();
		printf("SymInitialize ERROR : %d\n", error);
		return FALSE;
	}

	DWORD  dwDisplacement = 0;
	DWORD64  dwAddress = (DWORD64)test;

	BOOL result = FALSE;

	{
		IMAGEHLP_SYMBOL64 *pSym = NULL;
		char buffer[sizeof(IMAGEHLP_SYMBOL64) + MAX_SYM_NAME*sizeof(TCHAR)] = { 0 };
		pSym = (IMAGEHLP_SYMBOL64 *)buffer;

		pSym->SizeOfStruct = sizeof(IMAGEHLP_SYMBOL64);
		pSym->MaxNameLength = MAX_PATH;
		DWORD64 dwDisplacement64 = 0;
		result = SymGetSymFromAddr64(thisProcess, dwAddress, &dwDisplacement64, pSym);
		if (result == TRUE)
		{
			printf("\n%s\n", pSym->Name);
		}
	}

	{

		IMAGEHLP_LINE64 line64 = { 0 };
		line64.SizeOfStruct = sizeof(IMAGEHLP_LINE64);
		dwDisplacement = 0;

		if (SymGetLineFromAddr64(thisProcess, dwAddress, &dwDisplacement, &line64))
		{
			printf("%s (%d)", line64.FileName, line64.LineNumber);
		}
		else
		{
			DWORD error = GetLastError();
			_tprintf(TEXT("SymGetLineFromAddr64 ERROR: %d\n"), error);
		}
	}

	SymCleanup(thisProcess);

	return 0;
}

